### Function Macro

# GObject DEFINE_TYPE_WITH_CODE

since: 2.4

#### Declaration

    #define G_DEFINE_TYPE_WITH_CODE (
      TN,
      t_n,
      T_P,
      _C_
    )

#### Description

A convenience macro for type implementations.

Similar to G_DEFINE_TYPE(), but allows you to insert custom code into the `*_get_type()` function, e.g. interface implementations via G_IMPLEMENT_INTERFACE(). See G_DEFINE_TYPE_EXTENDED() for an example.

Available since: 2.4

This function is not directly available to language bindings.

#### Parameters

`TN`

  Type: `-`

  The name of the new type, in Camel case.

`t_n`

  Type: `-`

  The name of the new type in lowercase, with words separated by `_`.

`T_P`

  Type: `-`

  The `GType` of the parent type.

`_C_`

  Type: `-`

  Custom code that gets inserted in the `*_get_type()` function.